package com.terraformersmc.traverse.feature;

import com.mojang.datafixers.Dynamic;
import com.terraformersmc.traverse.block.TraverseBlocks;
import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_2944;
import net.minecraft.class_3111;
import net.minecraft.class_3341;
import net.minecraft.class_3747;

public class FirTreeFeature extends class_2944<class_3111> {

    private final int minHeight;
    private final class_2680 log;
    private final class_2680 leaves;

    public FirTreeFeature(final Function<Dynamic<?>, ? extends class_3111> function, final boolean worldGen) {
        this(function, worldGen, 15);
    }

    public FirTreeFeature(final Function<Dynamic<?>, ? extends class_3111> function, final boolean worldGen, int minHeight) {
        this(function, worldGen, minHeight, TraverseBlocks.FIR_LOG.method_9564(), TraverseBlocks.FIR_LEAVES.method_9564());
    }

    public FirTreeFeature(final Function<Dynamic<?>, ? extends class_3111> function, final boolean worldGen, int minHeight, class_2680 log, class_2680 leaves) {
        super(function, worldGen);
        this.minHeight = minHeight;
        this.log = log;
        this.leaves = leaves;
    }

    @Override
    protected boolean method_12775(final Set<class_2338> blocks, final class_3747 world, final Random random, final class_2338 pos, final class_3341 box) {
        int height = random.nextInt(15) + minHeight;
        int logHeight = 4 + random.nextInt(2);
        int leavesHeight = height - logHeight;
        int l = 2 + random.nextInt(2);
        boolean canGenerate = true;

        if (pos.method_10264() >= 1 && pos.method_10264() + height + 1 <= 256) {
            for (int i1 = pos.method_10264(); i1 <= pos.method_10264() + 1 + height && canGenerate; ++i1) {
                int j1;

                if (i1 - pos.method_10264() < logHeight) {
                    j1 = 0;
                }
                else {
                    j1 = l;
                }

                class_2338.class_2339 checkPos = new class_2338.class_2339();

                for (int k1 = pos.method_10263() - j1; k1 <= pos.method_10263() + j1 && canGenerate; ++k1) {
                    for (int l1 = pos.method_10260() - j1; l1 <= pos.method_10260() + j1 && canGenerate; ++l1) {
                        if (i1 >= 0 && i1 < 256) {
                            if (!method_16432(world, checkPos.method_10103(k1, i1, l1))) {
                                canGenerate = false;
                            }
                        }
                        else {
                            canGenerate = false;
                        }
                    }
                }
            }

            if (!canGenerate) {
                return false;
            }
            else if (method_16433(world, pos.method_10074()) && pos.method_10264() < 256 - height - 1) {
                this.method_16427(world, pos.method_10074());
                int i3 = random.nextInt(2);
                int j3 = 1;
                int k3 = 0;

                for (int l3 = 0; l3 <= leavesHeight; ++l3) {
                    int leavesY = pos.method_10264() + height - l3;

                    for (int leavesX = pos.method_10263() - i3; leavesX <= pos.method_10263() + i3; ++leavesX) {
                        int j2 = leavesX - pos.method_10263();

                        for (int leavesZ = pos.method_10260() - i3; leavesZ <= pos.method_10260() + i3; ++leavesZ) {
                            int l2 = leavesZ - pos.method_10260();

                            if (Math.abs(j2) != i3 || Math.abs(l2) != i3 || i3 <= 0) {
                                class_2338 leavesPos = new class_2338(leavesX, leavesY, leavesZ);
                                if (method_16420(world, leavesPos)) {
                                    method_13153(world, leavesPos, leaves);
                                }
                            }
                        }
                    }

                    if (i3 >= j3) {
                        i3 = k3;
                        k3 = 1;
                        ++j3;

                        if (j3 > l) {
                            j3 = l;
                        }
                    }
                    else {
                        ++i3;
                    }
                }

                int i4 = random.nextInt(3);

                for (int k4 = 0; k4 < height - i4; ++k4) {
                    if (method_16420(world, pos.method_10086(k4)) || method_16425(world, pos.method_10086(k4))) {
                        this.method_12773(blocks, world, pos.method_10086(k4), this.log, box);
                    }
                }
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    }

}
